---
title: overflow
slug: Web/CSS/overflow
tags:
  - CSS
  - CSS Box Model
  - CSS Property
  - Clipping
  - Layout
  - Reference
  - overflow
  - 'recipe:css-shorthand-property'
  - scrolling
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>overflow</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand property</a> sets the desired behavior for an element's overflow — i.e. when an element's content is too big to fit in its <a href="/en-US/docs/CSS/block_formatting_context">block formatting context</a> — in both directions.</span></p>

<div>{{EmbedInteractiveExample("pages/css/overflow.html")}}</div>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
 <li><a href="/en-US/docs/Web/CSS/overflow-x"><code>overflow-x</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/overflow-y"><code>overflow-y</code></a></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
overflow: visible;
overflow: hidden;
overflow: clip;
overflow: scroll;
overflow: auto;
overflow: hidden visible;

/* Global values */
overflow: inherit;
overflow: initial;
overflow: unset;
</pre>

<p>The <code>overflow</code> property is specified as one or two keywords chosen from the list of values below. If two keywords are specified, the first applies to <code>overflow-x</code> and the second to <code>overflow-y</code>. Otherwise, both <code>overflow-x</code> and <code>overflow-y</code> are set to the same value.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>visible</code></dt>
 <dd>Content is not clipped and may be rendered outside the padding box.</dd>
 <dt><code>hidden</code></dt>
 <dd>Content is clipped if necessary to fit the padding box. No scrollbars are provided, and no support for allowing the user to scroll (such as by dragging or using a scroll wheel) is allowed. The content <em>can</em> be scrolled programmatically (for example, by setting the value of a property such as {{domxref("HTMLElement.offsetLeft", "offsetLeft")}}), so the element is still a scroll container.</dd>
 <dt><code>clip</code> {{experimental_inline}}</dt>
 <dd>Like for <code>hidden</code>, the content is clipped to the element's padding box. The difference between <code>clip</code> and <code>hidden</code> is that the <code>clip</code> keyword also forbids all scrolling, including programmatic scrolling. The box is not a scroll container, and does not start a new formatting context. If you wish to start a new formatting context, you can use {{cssxref("display", "display: flow-root", "#flow-root")}} to do so.</dd>
 <dt><code>scroll</code></dt>
 <dd>Content is clipped if necessary to fit the padding box. Browsers always display scrollbars whether or not any content is actually clipped, preventing scrollbars from appearing or disappearing as content changes. Printers may still print overflowing content.</dd>
 <dt><code>auto</code></dt>
 <dd>Depends on the {{Glossary("user agent")}}. If content fits inside the padding box, it looks the same as <code>visible</code>, but still establishes a new block formatting context. Desktop browsers provide scrollbars if content overflows.</dd>
</dl>

<dl>
 <dt><code>overlay</code> {{deprecated_inline}}</dt>
 <dd>Behaves the same as <code>auto</code>, but with the scrollbars drawn on top of content instead of taking up space. Only supported in WebKit-based (e.g., Safari) and Blink-based (e.g., Chrome or Opera) browsers.</dd>
</dl>

<h4 id="Mozilla_extensions">Mozilla extensions</h4>

<dl>
 <dt><code>-moz-scrollbars-none</code> {{obsolete_inline}}<a href="#Deprecated">[1]</a></dt>
 <dd>Use <code>overflow: hidden</code> instead.</dd>
 <dt><code>-moz-scrollbars-horizontal</code> {{deprecated_inline}}<a href="#Deprecated">[1]</a></dt>
 <dd>Use <code>{{Cssxref("overflow-x")}}: scroll</code> and <code>{{Cssxref("overflow-y")}}: hidden</code>, or <code>overflow: hidden scroll</code> instead.</dd>
 <dt><code>-moz-scrollbars-vertical</code> {{deprecated_inline}}<a href="#Deprecated">[1]</a></dt>
 <dd>Use <code>{{Cssxref("overflow-x")}}: hidden</code> and <code>{{Cssxref("overflow-y")}}: scroll</code>, or <code>overflow: scroll hidden</code> instead.</dd>
 <dt><code>-moz-hidden-unscrollable</code> {{obsolete_inline}}</dt>
 <dd>Use <code>overflow: clip</code> instead.</dd>
</dl>

<p id="Deprecated">[1] As of Firefox 63, this feature is behind a feature preference setting. In about:config, set <code>layout.css.overflow.moz-scrollbars.enabled</code> to <code>true</code></p>

<h2 id="Description">Description</h2>

<p>Overflow options include clipping, showing scrollbars, or displaying the content flowing out of its container into the surrounding area.</p>

<p>Specifying a value other than <code>visible</code> (the default) creates a new <a href="/en-US/docs/CSS/block_formatting_context">block formatting context</a>. This is necessary for technical reasons — if a float intersected with the scrolling element it would forcibly rewrap the content after each scroll step, leading to a slow scrolling experience.</p>

<p>In order for <code>overflow</code> to have an effect, the block-level container must have either a set height (<code>height</code> or <code>max-height</code>) or <code>white-space</code> set to <code>nowrap</code>.</p>

<p>Setting one axis to <code>visible</code> (the default) while setting the other to a <em>different</em> value results in <code>visible</code> behaving as <code>auto</code>.</p>

<p>The JavaScript {{domxref("Element.scrollTop")}} property may be used to scroll an HTML element even when <code>overflow</code> is set to <code>hidden</code>.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_different_overflow_values_for_text">Setting different overflow values for text</h3>

<pre class="brush: css notranslate">p {
  width: 12em;
  height: 6em;
  border: dotted;
  overflow: visible; /* content is not clipped */
}
</pre>

<p style="overflow: visible; display: inline-block; width: 12em; height: 6em; border: dotted;"><code>visible</code> (default)<br>
 Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium.</p>

<pre class="brush: css notranslate">p { overflow: hidden; /* no scrollbars are provided */ }
</pre>

<p style="overflow: hidden; display: inline-block; width: 12em; height: 6em; border: dotted;"><code>overflow: hidden</code><br>
 Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium.</p>

<pre class="brush: css notranslate">p { overflow: scroll; /* always show scrollbars */ }
</pre>

<p style="overflow: scroll; display: inline-block; width: 12em; height: 6em; border: dotted;"><code>overflow: scroll</code><br>
 Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium.</p>

<pre class="brush: css notranslate">p { overflow: auto; /* append scrollbars if necessary */ }
</pre>

<p style="overflow: auto; display: inline-block; width: 12em; height: 6em; border: dotted;"><code>overflow: auto</code><br>
 Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Overflow', '#propdef-overflow', 'overflow')}}</td>
   <td>{{Spec2('CSS3 Overflow')}}</td>
   <td>
    <p>Changed syntax to allow one or two keywords instead of only one</p>
   </td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'visufx.html#overflow', 'overflow')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.overflow")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related CSS properties: {{cssxref("text-overflow")}}, {{cssxref("white-space")}}, {{Cssxref("overflow-x")}}, {{Cssxref("overflow-y")}}, {{Cssxref("overflow-inline")}}, {{Cssxref("overflow-block")}}, {{Cssxref("clip")}}, {{Cssxref("display")}}</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Overflow">CSS Overflow</a> and <a href="/en-US/docs/Tools/Page_Inspector/How_to/Debug_Scrollable_Overflow">Debug scrollable overflow</a></li>
</ul>
